/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
)


// DnAPIService DnAPI service
type DnAPIService service

type ApiCreateDNConfigurationRequest struct {
	ctx context.Context
	ApiService *DnAPIService
	oid string
	createDNConfigRequest *CreateDNConfigRequest
}

func (r ApiCreateDNConfigurationRequest) CreateDNConfigRequest(createDNConfigRequest CreateDNConfigRequest) ApiCreateDNConfigurationRequest {
	r.createDNConfigRequest = &createDNConfigRequest
	return r
}

func (r ApiCreateDNConfigurationRequest) Execute() (*DNConfiguration, *http.Response, error) {
	return r.ApiService.CreateDNConfigurationExecute(r)
}

/*
CreateDNConfiguration Create DN configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiCreateDNConfigurationRequest
*/
func (a *DnAPIService) CreateDNConfiguration(ctx context.Context, oid string) ApiCreateDNConfigurationRequest {
	return ApiCreateDNConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
//  @return DNConfiguration
func (a *DnAPIService) CreateDNConfigurationExecute(r ApiCreateDNConfigurationRequest) (*DNConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *DNConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DnAPIService.CreateDNConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/dn/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.createDNConfigRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiDeleteDNConfigurationRequest struct {
	ctx context.Context
	ApiService *DnAPIService
	oid string
}

func (r ApiDeleteDNConfigurationRequest) Execute() (*http.Response, error) {
	return r.ApiService.DeleteDNConfigurationExecute(r)
}

/*
DeleteDNConfiguration Delete DN configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiDeleteDNConfigurationRequest
*/
func (a *DnAPIService) DeleteDNConfiguration(ctx context.Context, oid string) ApiDeleteDNConfigurationRequest {
	return ApiDeleteDNConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
func (a *DnAPIService) DeleteDNConfigurationExecute(r ApiDeleteDNConfigurationRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DnAPIService.DeleteDNConfiguration")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/dn/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiGetDNConfigurationRequest struct {
	ctx context.Context
	ApiService *DnAPIService
	oid string
}

func (r ApiGetDNConfigurationRequest) Execute() (*DNConfiguration, *http.Response, error) {
	return r.ApiService.GetDNConfigurationExecute(r)
}

/*
GetDNConfiguration Get DN configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiGetDNConfigurationRequest
*/
func (a *DnAPIService) GetDNConfiguration(ctx context.Context, oid string) ApiGetDNConfigurationRequest {
	return ApiGetDNConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
//  @return DNConfiguration
func (a *DnAPIService) GetDNConfigurationExecute(r ApiGetDNConfigurationRequest) (*DNConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *DNConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DnAPIService.GetDNConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/dn/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
